/**
 * Header file for project utility logic.
 */


// System Import Headers.
#include <cctype>
#include <cstdio>
#include <cstdlib>
#include <filesystem>
#include <fstream>
#include <iostream>
#include <string>


// Global Variables.
extern const int TYPE_DIR;
extern const int TYPE_FILE;
extern const int TYPE_OTHER;


/**
 * Data return for path validation function.
 */
typedef struct {
    int file_type;
    std::error_code err_code;
} path_validator_struct;


// // Function Prototypes.
path_validator_struct* initialize_path_validator_struct(int file_type, std::error_code err_code);
void free_path_validator_struct(path_validator_struct* path_validator_ptr);
path_validator_struct* validate_path(std::string path_str);
